【LeetCode】169. 多数元素(摩尔投票法)

给定一个大小为 n 的数组,找到其中的多数元素。多数元素是指在数组中出现次数大于?? n/2 ??的元素。

你可以假设数组是非空的,并且给定的数组总是存在多数元素。

示例?1:
输入: [3,2,3]
输出: 3
示例?2:
输入: [2,2,1,1,1,2,2]
输出: 2

代码:

解法一:哈希统计

class Solution {
    public int majorityElement(int[] nums) {
         int len=nums.length;
         int count=1;
        int[] flag = new int[len + 1];
        Arrays.fill(flag, 0);
        for(int i=0;i<len;i++){
            if(flag[i]==0){
                flag[i]=1;
                for(int j=i+1;j<len;j++){
                    if(nums[i]==nums[j]){
                        flag[j]=1;
                        count++;
                    }
                }
            }else{
                continue;
            }
            if(count>len/2){
                return nums[i];
            }
        }
        return -1;
    }
}

解法二:排序后取中位数

class Solution {
    public int majorityElement(int[] nums) {
        Arrays.sort(nums);
        return nums[nums.length/2];
    }
}

解法三:摩尔投票法

摩尔投票法存在一个大前提:数组中必须有一个元素出现的次数占了所有元素数量的1/2,假设第一个数为res,后面遇到事相同数字就cnt++,否则cnt--,当cnt == 0时,替换res,最后得到的res一定为多数元素

class Solution {
    public int majorityElement(int[] nums) {
        int res = 0, cnt = 0;
        for (int num : nums) {
            if (cnt == 0) {res = num; ++cnt;}
            else if (num == res) ++cnt;
            else --cnt;
        }
        return res;
    }
}

原文地址:https://www.cnblogs.com/whisperbb/p/12629418.html

时间: 2024-10-15 11:30:50

【LeetCode】169. 多数元素(摩尔投票法)的相关文章

LeetCode题解-----Majority Element II 摩尔投票法

题目描述: Given an integer array of size n, find all elements that appear more than ⌊ n/3 ⌋ times. The algorithm should run in linear time and in O(1) space. 分析: 因为要找出的是出现次数大于⌊ n/3 ⌋的元素,因此最多只可能存在两个这样的元素,而且要求O(1)的空间复杂度,因此只能使用摩尔投票法.首先我们遍历一遍数组找出两个候选元素,接着再遍历

leetcode 169. Majority Element 多数投票算法(Boyer-Moore Majority Vote algorithm)

题目: Given an array of size n, find the majority element. The majority element is the element that appears more than ⌊ n/2 ⌋ times. You may assume that the array is non-empty and the majority element always exist in the array. 题解:运用多数投票算法的思路来解:从头到尾遍历数

LeetCode 169. Majority Element (众数)

Given an array of size n, find the majority element. The majority element is the element that appears more than ? n/2 ? times. You may assume that the array is non-empty and the majority element always exist in the array. 题目标签:Array 忘记说了,特地回来补充,今天看完<

Leetcode#169. Majority Element(求众数)

题目描述 给定一个大小为 n 的数组,找到其中的众数.众数是指在数组中出现次数大于 ? n/2 ? 的元素. 你可以假设数组是非空的,并且给定的数组总是存在众数. 示例 1: 输入: [3,2,3] 输出: 3 示例 2: 输入: [2,2,1,1,1,2,2] 输出: 2 思路 思路一: 利用哈希表的映射,储存数组中的数字以及它们出现的次数,当众数出现时,返回这个数字. 思路二: 因为众数是出现次数大于n/2的数字,所以排序之后中间的那个数字一定是众数.即nums[n/2]为众数.但是在计算比

【LeetCode 169】Majority Element

Given an array of size n, find the majority element. The majority element is the element that appears more than ⌊ n/2 ⌋ times. You may assume that the array is non-empty and the majority element always exist in the array. 思路: 找到一个数组中出现次数超过一半的数.排序.哈希等

查找之摩尔投票算法

对于一个一位数组array[1,5,1,3,2,3,3,3,4,9,6,4,3,3,3,3],找出其中超过数组中一半长度的数.今天学到了一种是摩尔投票算法.其他的一种算法是首先对数组进行排序,这样从小到大,并且超过一半,该数存在的话一定在数组的正中间.这样最后对该数进行检查一遍,因为有可能对于刚好是等于一半的数. 摩尔投票算法的思想是,首先定义一个majority和一个count,majority用来存放当前出现次数最多的数.如当majority等于第一个数后,count=1:然后majorit

luogu P3765 总统选举(线段树维护摩尔投票+平衡树)

这题需要一个黑科技--摩尔投票.这是一个什么东西?一个神奇的方法求一个序列中出现次数大于长度一半的数. 简而言之就是同加异减: 比如有一个代表投票结果的序列. \[[1,2,1,1,2,1,1]\] 我们记录一个\(num\)和\(cnt\)先别管它们是干什么的.我们模拟一遍模拟排序. \[首先读第一个数1,num==0,我们把cnt+1=1,num=1\] \[第二个数2,num==1\neq2,我们把cnt-1=0,num不变\] \[然后第三个数1,num==0,我们把cnt+1=1,nu

leetcode——169 Majority Element(数组中出现次数过半的元素)

Given an array of size n, find the majority element. The majority element is the element that appears more than  n/2  times. You may assume that the array is non-empty and the majority element always exist in the array. Hide Tags: Divide and Conquer

[Lintcode]46. Majority Element/[Leetcode]169. Majority Element

46. Majority Element/[169. Majority Element(https://leetcode.com/problems/majority-element/) 本题难度: Easy Topic: Greedy Description Given an array of integers, the majority number is the number that occurs more than half of the size of the array. Find